﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;


using System.IO;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public static string fileName { get; set; }
        public static string destination { get; set; }
        public ActionResult Index()
        {
            ViewBag.dataSource2 = new NorthwindDataContext().OrdersViews.ToList();
            return View();
        }
        public ActionResult GrdBatchUpdate(string action, List<EditableOrder> added, List<EditableOrder> changed, List<EditableOrder> deleted, int? key)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult GrdEntlDataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords().ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.count = Data.AsQueryable().Count();
            if (dm.Skip != null)
                Data = operation.PerformSkip(Data, dm.Skip);
            if (dm.Take != null)
                Data = operation.PerformTake(Data, dm.Take);
            result.result = Data;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult saveFiles()
        {
            if (HttpContext.Request.Files.AllKeys.Any())
            {
                var httpPostedFile = HttpContext.Request.Files["FlatGridEmployeeID"];

                if (httpPostedFile != null)
                {
                    if (httpPostedFile.FileName.Contains("\\"))
                    {
                        string[] pathArr = httpPostedFile.FileName.Split('\\');
                        fileName = pathArr.Last();
                    }
                    else
                        fileName = httpPostedFile.FileName;
                    destination = Path.Combine(HttpContext.Server.MapPath("~/App_Data"), fileName);
                    // To avoid unwanted storage in server we have commentted the below line
                    httpPostedFile.SaveAs(destination);
                }
            }
            return Content(destination);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}