System.register(["./core"], function (exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var core_1, Grid_CommandDirective, Grid_CommandsDirective, GridTemplateDirective, Grid_ColumnDirective, Grid_ColumnsDirective, Grid_SummaryColumnDirective, Grid_SummaryColumnsDirective, Grid_SummaryRowDirective, Grid_SummaryRowsDirective, Grid_StackedHeaderColumnDirective, Grid_StackedHeaderColumnsDirective, Grid_StackedHeaderRowDirective, Grid_StackedHeaderRowsDirective, Outputs, ComplexProperties, Inputs, GridComponent, EJ_GRID_COMPONENTS;
    return {
        setters: [
            function (core_1_1) {
                core_1 = core_1_1;
            }
        ],
        execute: function () {
            exports_1("Grid_CommandDirective", Grid_CommandDirective = core_1.CreateComplexDirective({
                selector: 'e-commands>e-command',
                inputs: ['buttonOptions', 'type'],
                queries: {}
            }, {
                tags: [],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_CommandsDirective", Grid_CommandsDirective = core_1.CreateArrayTagDirective('commands', 'e-columns>e-commands', Grid_CommandDirective));
            exports_1("GridTemplateDirective", GridTemplateDirective = core_1.CreateTemplateDirective({
                selector: "[e-template]"
            }, {
                type: core_1.forwardRef(function () { return Grid_ColumnDirective; })
            }));
            exports_1("Grid_ColumnDirective", Grid_ColumnDirective = core_1.CreateComplexDirective({
                selector: 'e-columns>e-column',
                inputs: ['clipMode', 'allowEditing', 'allowFiltering', 'allowGrouping', 'allowSorting',
                    'allowResizing', 'commands', 'cssClass', 'customAttributes', 'dataSource',
                    'defaultValue', 'disableHtmlEncode', 'displayAsCheckBox', 'editParams', 'editTemplate',
                    'editType', 'enableGroupByFormat', 'field', 'filterBarTemplate', 'foreignKeyField',
                    'foreignKeyValue', 'format', 'headerTemplateID', 'headerText', 'headerTextAlign',
                    'isFrozen', 'isIdentity', 'isPrimaryKey', 'priority', 'showInColumnChooser',
                    'template', 'textAlign', 'tooltip', 'type', 'validationRules',
                    'visible', 'width'],
                queries: {
                    _commands: new core_1.ContentChild(Grid_CommandsDirective),
                    _template: new core_1.ContentChild(GridTemplateDirective)
                }
            }, {
                tags: ['commands'],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_ColumnsDirective", Grid_ColumnsDirective = core_1.CreateArrayTagDirective('columns', 'ej-grid>e-columns', Grid_ColumnDirective));
            exports_1("Grid_SummaryColumnDirective", Grid_SummaryColumnDirective = core_1.CreateComplexDirective({
                selector: 'e-summarycolumns>e-summarycolumn',
                inputs: ['customSummaryValue', 'dataMember', 'displayColumn', 'format', 'prefix',
                    'suffix', 'summaryType', 'template'],
                queries: {}
            }, {
                tags: [],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_SummaryColumnsDirective", Grid_SummaryColumnsDirective = core_1.CreateArrayTagDirective('summaryColumns', 'e-summaryrows>e-summarycolumns', Grid_SummaryColumnDirective));
            exports_1("Grid_SummaryRowDirective", Grid_SummaryRowDirective = core_1.CreateComplexDirective({
                selector: 'e-summaryrows>e-summaryrow',
                inputs: ['showCaptionSummary', 'showGroupSummary', 'showTotalSummary', 'summaryColumns', 'title',
                    'titleColumn'],
                queries: {
                    _summaryColumns: new core_1.ContentChild(Grid_SummaryColumnsDirective),
                }
            }, {
                tags: ['summaryColumns'],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_SummaryRowsDirective", Grid_SummaryRowsDirective = core_1.CreateArrayTagDirective('summaryRows', 'ej-grid>e-summaryrows', Grid_SummaryRowDirective));
            exports_1("Grid_StackedHeaderColumnDirective", Grid_StackedHeaderColumnDirective = core_1.CreateComplexDirective({
                selector: 'e-stackedheadercolumns>e-stackedheadercolumn',
                inputs: ['column', 'cssClass', 'headerText', 'textAlign'],
                queries: {}
            }, {
                tags: [],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_StackedHeaderColumnsDirective", Grid_StackedHeaderColumnsDirective = core_1.CreateArrayTagDirective('stackedHeaderColumns', 'e-stackedheaderrows>e-stackedheadercolumns', Grid_StackedHeaderColumnDirective));
            exports_1("Grid_StackedHeaderRowDirective", Grid_StackedHeaderRowDirective = core_1.CreateComplexDirective({
                selector: 'e-stackedheaderrows>e-stackedheaderrow',
                inputs: ['stackedHeaderColumns'],
                queries: {
                    _stackedHeaderColumns: new core_1.ContentChild(Grid_StackedHeaderColumnsDirective),
                }
            }, {
                tags: ['stackedHeaderColumns'],
                complexes: [],
                type: core_1.forwardRef(function () { return GridComponent; })
            }));
            exports_1("Grid_StackedHeaderRowsDirective", Grid_StackedHeaderRowsDirective = core_1.CreateArrayTagDirective('stackedHeaderRows', 'ej-grid>e-stackedheaderrows', Grid_StackedHeaderRowDirective));
            Outputs = ['actionBegin', 'actionComplete', 'actionFailure', 'batchAdd', 'batchDelete',
                'beforeBatchAdd', 'beforeBatchDelete', 'beforeBatchSave', 'beginEdit', 'cellEdit',
                'cellSave', 'cellSelected', 'cellSelecting', 'columnDrag', 'columnDragStart',
                'columnDrop', 'rowDrag', 'rowDragStart', 'rowDrop', 'columnSelected',
                'columnSelecting', 'contextClick', 'contextOpen', 'create', 'dataBound',
                'destroy', 'detailsCollapse', 'detailsDataBound', 'detailsExpand', 'endAdd',
                'endDelete', 'endEdit', 'load', 'mergeCellInfo', 'queryCellInfo',
                'recordClick', 'recordDoubleClick', 'resized', 'resizeEnd', 'resizeStart',
                'rightClick', 'rowDataBound', 'rowSelected', 'rowSelecting', 'templateRefresh',
                'toolbarClick',
                'model.dataSourceChange: dataSourceChange', 'model.pageSettings.currentPageChange: pageSettings.currentPageChange'];
            ComplexProperties = ['contextMenuSettings', 'editSettings', 'filterSettings', 'groupSettings', 'pageSettings',
                'resizeSettings', 'rowDropSettings', 'searchSettings', 'selectionSettings', 'scrollSettings',
                'sortSettings', 'textWrapSettings', 'toolbarSettings'];
            Inputs = core_1.Utils.AngularizeInputs(['allowCellMerging', 'allowGrouping', 'allowKeyboardNavigation', 'allowFiltering', 'allowSorting',
                'allowMultiSorting', 'allowPaging', 'allowReordering', 'allowResizeToFit', 'allowResizing',
                'allowRowDragAndDrop', 'allowScrolling', 'allowSearching', 'allowSelection', 'allowTextWrap',
                'allowMultipleExporting', 'commonWidth', 'gridLines', 'childGrid', 'columnLayout',
                'contextMenuSettings', 'cssClass', 'detailsTemplate', 'editSettings', 'enableAltRow',
                'enableAutoSaveOnSelectionChange', 'enableHeaderHover', 'enablePersistence', 'enableResponsiveRow', 'enableRowHover',
                'enableRTL', 'enableTouch', 'filterSettings', 'groupSettings', 'isResponsive',
                'keySettings', 'locale', 'minWidth', 'pageSettings', 'query',
                'resizeSettings', 'rowTemplate', 'rowDropSettings', 'searchSettings', 'selectedRecords',
                'selectedRowIndex', 'selectedRowIndices', 'selectionSettings', 'selectionType', 'scrollSettings',
                'showColumnChooser', 'showStackedHeader', 'showSummary', 'sortSettings', 'textWrapSettings',
                'toolbarSettings', 'contextMenuSettings.contextMenuItems', 'contextMenuSettings.customContextMenuItems', 'contextMenuSettings.enableContextMenu', 'contextMenuSettings.disableDefaultItems',
                'editSettings.allowAdding', 'editSettings.allowDeleting', 'editSettings.allowEditing', 'editSettings.allowEditOnDblClick', 'editSettings.dialogEditorTemplateID',
                'editSettings.editMode', 'editSettings.externalFormTemplateID', 'editSettings.formPosition', 'editSettings.inlineFormTemplateID', 'editSettings.rowPosition',
                'editSettings.showConfirmDialog', 'editSettings.showDeleteConfirmDialog', 'editSettings.titleColumn', 'editSettings.showAddNewRow', 'filterSettings.enableCaseSensitivity',
                'filterSettings.filterBarMode', 'filterSettings.filterType', 'filterSettings.maxFilterChoices', 'filterSettings.showFilterBarMessage', 'filterSettings.showPredicate',
                'groupSettings.captionFormat', 'groupSettings.enableDropAreaAutoSizing', 'groupSettings.groupedColumns', 'groupSettings.showDropArea', 'groupSettings.showGroupedColumn',
                'groupSettings.showToggleButton', 'groupSettings.showUngroupButton', 'pageSettings.enableQueryString', 'pageSettings.enableTemplates', 'pageSettings.pageCount',
                'pageSettings.pageSize', 'pageSettings.showDefaults', 'pageSettings.template', 'pageSettings.totalPages', 'pageSettings.totalRecordsCount',
                'pageSettings.printMode', 'resizeSettings.resizeMode', 'rowDropSettings.dropTargetID', 'rowDropSettings.dragMapper', 'rowDropSettings.dropMapper',
                'searchSettings.fields', 'searchSettings.key', 'searchSettings.operator', 'searchSettings.ignoreCase', 'selectionSettings.enableToggle',
                'selectionSettings.selectionMode', 'scrollSettings.allowVirtualScrolling', 'scrollSettings.enableTouchScroll', 'scrollSettings.frozenColumns', 'scrollSettings.frozenRows',
                'scrollSettings.height', 'scrollSettings.virtualScrollMode', 'scrollSettings.enableVirtualization', 'scrollSettings.width', 'scrollSettings.scrollOneStepBy',
                'textWrapSettings.wrapMode', 'toolbarSettings.customToolbarItems', 'toolbarSettings.showToolbar', 'toolbarSettings.toolbarItems', 'columns',
                'stackedHeaderRows', 'summaryRows', 'contextMenuSettings.subContextMenu', 'filterSettings.filteredColumns', 'sortSettings.sortedColumns'], ['dataSource', 'pageSettings.currentPage']);
            exports_1("GridComponent", GridComponent = core_1.CreateComponent('Grid', {
                selector: 'ej-grid',
                inputs: Inputs,
                outputs: Outputs,
                template: '',
                queries: {
                    _columns: new core_1.ContentChild(Grid_ColumnsDirective),
                    _summaryRows: new core_1.ContentChild(Grid_SummaryRowsDirective),
                    _stackedHeaderRows: new core_1.ContentChild(Grid_StackedHeaderRowsDirective),
                }
            }, {
                tags: ['columns', 'summaryRows', 'stackedHeaderRows'],
                twoways: ['dataSource', 'pageSettings.currentPage'],
                complexes: ComplexProperties,
            }));
            exports_1("EJ_GRID_COMPONENTS", EJ_GRID_COMPONENTS = [GridComponent, Grid_CommandsDirective, Grid_ColumnsDirective, Grid_SummaryColumnsDirective, Grid_SummaryRowsDirective, Grid_StackedHeaderColumnsDirective, Grid_StackedHeaderRowsDirective, Grid_CommandDirective, Grid_ColumnDirective, Grid_SummaryColumnDirective, Grid_SummaryRowDirective, Grid_StackedHeaderColumnDirective, Grid_StackedHeaderRowDirective, GridTemplateDirective]);
        }
    };
});
//# sourceMappingURL=grid.component.js.map